//Diablo - By Gikon.
datablock ParticleData(DiabloParticle)
{
	dragCoefficient      = 2.9;
	gravityCoefficient   = 0.1;
	inheritedVelFactor   = 1.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 75;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.000000 0.000000 1.000000 1.000000";
	colors[1]     = "1.000000 0.496063 0.000000 0.000000";
   	colors[2]     = "1.000000 1.000000 1.000000 1.000000";
   	colors[3]     = "1.000000 1.000000 1.000000 1.000000";

	sizes[0]      = 0.0946103;
	sizes[1]      = 0.897272;
 	sizes[2]      = 1;
 	sizes[3]      = 1;

   	times[0] = 0;
   	times[1] = 1;
   	times[2] = 2;
  	times[3] = 2;

	useInvAlpha = false;
};

datablock ParticleEmitterData(DiabloEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 20;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 5;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   orientOnVelocity = true;
   particles = "DiabloParticle";
};

datablock ParticleData(DiablobulletTrailParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 625;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/thinRing";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.3 0.3 0.4";
	colors[1]     = "0.5 0.5 0.3 0.0";
	sizes[0]      = 0.15;
	sizes[1]      = 0.25;

	useInvAlpha = False;
};
datablock ParticleEmitterData(DiablobulletTrailEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "DiablobulletTrailParticle";
};
datablock ParticleData(DiabloExplosionParticle)
{
	dragCoefficient      = 2;
	gravityCoefficient   = 0.0;
	windCoefficient	   = 1;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 600;
	lifetimeVarianceMS   = 200;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 100.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "1.000000 0.496063 0.000000 0.496063";
	colors[1]     = "1.000000 0.496063 0.000000 0.000000";
	colors[2]     = "1.000000 1.000000 1.000000 1.000000";
	colors[3]     = "1.000000 1.000000 1.000000 1.000000";
	sizes[0]      = 0.799609;
	sizes[1]      = 1.19636;
	sizes[2]      = 1;
	sizes[3]      = 1;
	times[0]	  = 0;
	times[1]	  = 1;
	times[2]	  = 2;
	times[3]	  = 2;

	useInvAlpha = false;
};
datablock ParticleEmitterData(DiabloExplosionEmitter)
{
   ejectionPeriodMS = 40;
   periodVarianceMS = 0;
   ejectionVelocity = 3.5;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 35;
   thetaMax         = 85;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   orientOnVelocity = true;
   particles = "DiabloExplosionParticle";
};
datablock ExplosionData(DiabloExplosion)
{
   lifeTimeMS = 128;

   particleEmitter = DiabloExplosionEmitter;
   particleDensity = 10;
   particleRadius = 1;
   explosionScale = "1 1 1";
};
AddDamageType("Diablo",   '<bitmap:add-ons/Weapon_Diablo/CI_gun> %1',    '%2 <bitmap:add-ons/Weapon_Diablo/CI_gun> %1',0.2,1);
datablock ProjectileData(DiabloProjectile)
{
   directDamage        = 20;
   directDamageType = $DamageType::DiabloDirect;
   explosion           = DiabloExplosion;

   muzzleVelocity      = 25;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 300;
   fadeDelay           = 0;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;
};

//////////
// item //
//////////
datablock ItemData(DiabloItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./mini.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Diablo";
	iconName = "./Icon";
	doColorShift = true;
	colorShiftColor = "0.28 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = DiabloImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(DiabloImage)
{
   // Basic Item properties
   shapeFile = "./mini.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = DiabloProjectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = DiabloItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTransitionOnTriggerDown[0]  = "Fire";
	stateAllowImageChange[0]	   = true;
	stateSound[0]			   = weaponSwitchSound;
	stateTransitionOnTimeout[0]	   = "Ready";
	stateTimeoutValue[0]		   = 0.01;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateTimeoutValue[1]		   = 0.04;
	stateTransitionOnTimeout[1]	   = "Ready";
	stateWaitForTimeout[1]		   = true;
	stateAllowImageChange[1]	   = true;
	stateEmitter[1]			   = gunSmokeEmitter;
	stateEmitterTime[1]		   = 0.07;

	stateName[2]                     = "Fire";
	stateTransitionOnTriggerUp[2]	   = "StopFire";
	stateTransitionOnTimeout[2]	   = "Fire";
	stateTimeoutValue[2]		   = 0.04;
	stateWaitForTimeout[2]		   = true;
	stateFire[2]			   = true;
	stateAllowImageChange[2]	   = true;
	stateSound[2]			   = rocketLoopSound;
	stateScript[2]			   = "onFire";
	stateEmitter[2]			   = DiabloEmitter;
	stateEmitterTime[2]		   = 0.07;
	stateSequence[2]			   = "fire";

	stateName[3] 			   = "StopFire";
	stateTransitionOnTimeout[3]	   = "Ready";
	stateWaitForTimeout[3]		   = true;
	stateAllowImageChange[3]	   = true;
	stateSequence[3]			   = "stopfire";
};
function Player::stopBurn(%this)
{
	%this.isBurning=0;
}

function DiabloProjectile::onCollision(%this,%obj,%col,%pos,%fade)
{
	if(%col.getClassName() $= "Player" && %col.isBurning !$= 1 && miniGameCanDamage(%obj.client, %col) $= 1)
	{
		%col.isBurning=1;
		%col.schedule(8000,"stopBurn");
		%col.emote(playerNapalmBurnImage);
		%col.schedule(1000,"emote",playerBurnImage);
		%col.schedule(500,"setTempColor","0 0 0 1",5200);
		%col.schedule(5000,"burn");
	}
	Parent::onCollision(%this,%obj,%col,%pos,%fade);
}


